#ifndef FANNEXTRAS_H
#define FANNEXTRAS_H

#include <doublefann.h>


// Define the net. If NUM_LAYERS is changed, layer_neurons[] in main() must be updated!!
#define NUM_LAYERS         4
//#define NUM_INPUTS         17
#define NUM_INPUTS         14
//#define NUM_HIDDEN         36
#define NUM_HIDDEN         36
#define NUM_OUTPUTS        18



// Might as well put all data in here, since TrainingCallback needs some of them.
struct main_data_struct{
    // These are used before starting training.
    char *train_file,
         *verif_file,
         *net_in_file,
         *net_out_file;

    int algorithm,
        max_epochs,
        verif_epochs,
        best_epoch;

    float param1,
          param2,
          param3,
          target_error;

    struct fann_train_data *train_data;

    struct fann *ann;

    // These are used during verification.
    struct fann_train_data *verif_data;

    float error_verif_best,
          error_verif_curr,
          error_verif_prev,
          error_train_curr,
          error_train_prev;
};



// Function prototypes.
int FANN_API TrainingCallback(struct fann *ann, struct fann_train_data *train, unsigned int max_epochs, unsigned int epochs_between_reports, float desired_error, unsigned int epochs);
struct fann_train_data *TrainingDataLoad(char* filename);
void FANN_API TrainingDataMove(unsigned int num_data, unsigned int num_input, unsigned int num_output, fann_type *fann_in, fann_type *fann_out);

#endif // FANNEXTRAS_H
