function [b, a, delay] = AntiAliasingFilter()
% Create anti-aliasing filter, with 60 dB attenuation at 4 kHz,
% and passband up to 3.7 kHz (for 16 kHz samplerate).

[n, w] = ellipord(3.7/8, 4/8, 0.05, 60);
[b, a] = ellip(n, 0.05, 60, w, 'low');
temp = grpdelay(b, a, 0:1e2:4e3, 16e3);
delay = round(mean(temp));
