function [b, a, delay] = BandPassFilter()
% Create highpass filter for use in BP-MGN.
% In combination with the POTS band filter, this gives a bandpass filter
% with corner frequencies at approximately 2.67 and 3.4 kHz.

a = 1;
b = fir1(40, 2.5/8, 'high');

temp = grpdelay(b, a, (2.5e3:1e2:3.5e3), 16e3);
delay = round(mean(temp)); % 20 samples.. small enough to ignore.
