function [b, a, delay] = HighPassFilter()
% Creates high pass filter that minimizes overlap of POTS band and 
% extended signal. Assumes 16 kHz samplerate!

[n, w] = ellipord(3.7/8, 3/8, 0.05, 40);
[b, a] = ellip(n, 0.05, 40, w, 'high'); 
temp = grpdelay(b, a, (3.4e3:1e2:8e3), 16e3);
delay = round(mean(temp)); % ~4 samples.. does not matter much.
