function [] = LinuxPlay (x, varargin)
% Function that plays .WAVs on a Linux system (with aplay installed!)
% Optional parameters are samplerate, bit resolution and filename.
% Will default to 44.1 kHz, 16 bit, temp.wav.

F_sample = 44.1e3;
N_bits = 16;
filename = 'temp.wav';

switch(nargin)
    case {2}
        F_sample = varargin{1};

    case {3}
        F_sample = varargin{1};
        N_bits = varargin{2};

    case {4}
        F_sample = varargin{1};
        N_bits = varargin{2};
        filename = varargin{3};
end

x_max = max(abs(x));

wavwrite(x, F_sample, N_bits, filename);
system(['aplay ' filename]);