function [lifter] = MakeLifter(k_lifter, num_ceps)
% Create lifter for cepstrum.
%
% Input arguments
% k_lifter : multiplication factor for lifter (>= 2)
% num_ceps : number of cepstral coefficients (including c0)
%
% Output
% lifter : the lifter vector

L = k_lifter*num_ceps;
lifter = 1 + L/2 * sin((0:num_ceps-1) * pi / L);
