function [b, a, delay] = PotsFilter()
% Create POTS filter, with approximately -3 dB gain at 300 and 3.4k Hz, and
% maximum attenuation before 4 kHz. This allows for downsampling to 8 kHz
% without aliasing. (Assumes 16 kHz sample rate!)
%
% Group delay is 50 samples across the entire spectrum.

% Simple simulation of POTS-band.
[b, a] = fir1(100, 2*[2.4e2 3.465e3]/16e3);
temp = grpdelay(b, a, (3e2:1e2:3.4e3), 16e3);
delay = round(mean(temp));
