function [y] = binread(filename, endian, skipints)
% Read sound file from .BIN-format (specific to NST database?)

if ~exist('endian', 'var')
    endian = 'big';
end

if ~exist('skipints', 'var')
    skipints = 8;
end


if exist(filename, 'file')
    switch endian
        case 'big'
            fid = fopen(filename, 'r', 'b');
        case 'little'
            fid = fopen(filename, 'r', 'l');
    end

    contents = fread(fid, inf, 'short');
    fclose(fid);
    y = contents(skipints+1:end)/2^15;
else
    disp(['File ' filename ' does not exist!']);
    y = [];
end
